package com.eactive.eai.agent.routing;

import com.eactive.eai.agent.command.Command;
import com.eactive.eai.agent.command.CommandException;
import com.eactive.eai.common.routing.RoutingManager;
import com.eactive.eai.common.util.Logger;

public class ReloadRoutingCommand extends Command {

	private static final long serialVersionUID = 1L;

	public ReloadRoutingCommand() {
		super("ReloadRoutingCommand");
	}

	public Object execute() throws CommandException {
		Logger logger = Logger.getLogger(Logger.LOGGER_DEFAULT);
		if (logger.isInfo())
			logger.info(this.name + " is executed");

		if (!(args instanceof String)) {
			String rspErrorCode = "RECEAIMCM001";
			String msg = makeException(rspErrorCode, null);
			if (logger.isError())
				logger.error(msg);
			throw new CommandException(msg);
		}

		try {
			RoutingManager manager = RoutingManager.getInstance();
			String keyName = null;

			keyName = (String) args;
			if (keyName != null) {
				if ("ALL".equals(keyName)) {
					manager.reload();
					if (logger.isWarn())
						logger.warn(this.name + "] all rule Reload.");
				} else {
					manager.reload(keyName);
					if (logger.isWarn())
						logger.warn(this.name + "] " + keyName + " Reload.");
				}
			}

		} catch (Exception e) {
			String rspErrorCode = "RECEAIMCM002";
			String msg = makeException(rspErrorCode, e);
			if (logger.isError())
				logger.error(msg, e);
			throw new CommandException(msg);
		}
		return "success";

	}

}
